#ifndef __Mt_Common_H__
#define __Mt_Common_H__

#include <stdarg.h>
#include <list>
#include <string>
#include <vector>

namespace MaskTools {

typedef unsigned char Byte;
typedef short Word;
typedef std::string String;

typedef void PlaneProcessor;
typedef PlaneProcessor *PPlaneProcessor;

static inline Byte applyThresholds(int nValue, Byte nLow, Byte nHigh) { return nValue <= nLow ? 0 : (nValue > nHigh ? 255 : nValue); }
static inline int floatToInt(double x) { return x < 0 ? int(x - 0.5f) : int(x + 0.5f); }
static inline int clip(int a, int min, int max ) { return a < min ? min : (a > max ? max : a); }

typedef enum {
   LOG_ERROR,
   LOG_WARNING,
   LOG_INFO,
   LOG_DEBUG, 

} LogLevel;

void print(LogLevel, const char *, ...);

}

#define MT_HAVE_BOOST_SPIRIT  /* compile define */
#define MT_HAVE_SOFTWIRE      /* compile define */

#endif
