#ifndef __Mt_Picture_H__
#define __Mt_Picture_H__

#include "../../common/common.h"

namespace MaskTools { namespace Picture {

template <class T>
class Plane_T {
   T *pPlane;
   int nPitch;
public:
   Plane_T()                        : pPlane(0)       , nPitch(0)       { }
   Plane_T(T *pPlane, int nPitch)   : pPlane(pPlane)  , nPitch(nPitch)  { }

   int pitch() const { return nPitch; }
   T *plane() const { return pPlane; }
   T *plane(int nX, int nY) const { return pPlane + nX + nY * nPitch; }
   Plane_T<T> offset_plane(int nX, int nY) const { return Plane_T<T>(plane(nX, nY), nPitch); }
};

template<class T>
class Frame_T {
   Plane_T<T> Y, U, V;
public:
   Frame_T() { }
   Frame_T(const Plane_T<T> &Y, const Plane_T<T> &U, const Plane_T<T> &V) : Y(Y), U(U), V(V) { }

   Plane_T<T> y() const { return Y; }
   Plane_T<T> u() const { return U; }
   Plane_T<T> v() const { return V; }
};

typedef Plane_T<const Byte> CPlane;
typedef Plane_T<Byte> Plane;
typedef Frame_T<const Byte> CFrame;
typedef Frame_T<Byte> Frame;

} }

#endif
