#ifndef __Mt_BaseFunctions_H__
#define __Mt_BaseFunctions_H__

#include "../common.h"

namespace MaskTools { namespace Functions {

typedef void (Memset)(Byte *pPlane, int nPitch, int nWidth, int nHeight, Byte value);

typedef void (Copy)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch,
                    int nWidth, int Height);

typedef void (Prefetch)(const Byte *pDst, int nWidth);

Memset memset_c;
extern "C" Memset memset8_mmx;
extern "C" Memset memset8_isse;
extern "C" Memset memset8_3dnow;

Copy copy_c;
extern "C" Copy copy8_mmx;
extern "C" Copy copy8_isse;
extern "C" Copy copy8_3dnow;

Prefetch prefetch_nothing_c;
extern "C" Prefetch prefetch_c;
extern "C" Prefetch prefetch_isse;

} }

#endif
