#ifndef __Mt_Blur_H__
#define __Mt_Blur_H__

#include "../../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Blur { namespace Mapped {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch,
                        const Byte *pMask, int nMaskPitch, const Word *matrix, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
   Word matrix[10];

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

extern Processor *mapped_below_c;
extern Processor *mapped_all_c;

} } } }

#endif