#ifndef __Mt_Convolution_H__
#define __Mt_Convolution_H__

#include "../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Convolution {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch, void *, void *, void *, int nHorizontal, int nVertical, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
   int *i_horizontal, *i_vertical;
   float *f_horizontal, *f_vertical;
   int i_total;
   float f_total;
   void *horizontal, *vertical;
   void *total;

   int nHorizontal;
   int nVertical;
protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);
   ~Filter();

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

extern Processor *convolution_f_s_c;
extern Processor *convolution_i_s_c;
extern Processor *convolution_f_m_c;
extern Processor *convolution_i_m_c;

} } }

#endif