#ifndef __Mt_Lutxy_H__
#define __Mt_Lutxy_H__

#include "../../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Lut { namespace Dual {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch, int nWidth, int nHeight, const Byte lut[65536], Functions::Prefetch *prefetch);

class Filter : public MaskTools::Filter
{
   Byte yLut[65536], uLut[65536], vLut[65536];

   Functions::Prefetch *prefetch;

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

Processor lut_c;

} } } }


#endif