#ifndef __Mt_Motionmask_H__
#define __Mt_Motionmask_H__

#include "../../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Mask { namespace Motion {

typedef bool (Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch, int nLowThreshold, int nHighThreshold, int nMotionThreshold, int nSceneChange, int nSceneChangeValue, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
   int nLowThresholdY;
   int nHighThresholdY;
   int nLowThresholdUV;
   int nHighThresholdUV;
   int nMotionThreshold;

   int nSceneChange;
   int nSceneChangeValue;

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

extern Processor *mask_c;
extern Processor *mask8_mmx;
extern Processor *mask8_isse;
extern Processor *mask8_3dnow;

} } } }

#endif