#ifndef __Mt_MorphologicFilter_H__
#define __Mt_MorphologicFilter_H__

#include "../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Morphologic {

typedef void (Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch, int nMaxDeviation, const int *pCoordinates, int nCoordinates, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
   int nMaxDeviation, nMaxDeviationUV;
   int *pCoordinates, nCoordinates;
   Filter(const Filter &filter);

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                        Picture::CPlane &src2, Picture::CPlane &src3);

   void FillCoordinates(const String &coordinates);

public:
   Filter(const Parameters::Parameters &parameters);
   ~Filter();

   static Clip::Inputs inputClips;
};

} } }

#endif